unit ExeStr;
{
   +-----------------------------------+
   \             ExeStream             \
   \            Version 1.0            \
   \               2004                \
   +-----------------------------------+
                                                }
interface

uses Classes, SysUtils, Windows;

type
  TExeStream=class(TObject)
  private
    fStart:Integer;
    fMark:Cardinal;
    str:TFileStream;
  public
    constructor Create(FName:String;ReadOnly:Boolean);overload;
    destructor Destroy;override;
    function Read(var Buffer;Count:Integer):Integer;
    function Write(var Buffer;Count:Integer):Integer;
    function Seek(Offset:Longint;Origin:Word):Longint;
    function Size:Int64;
    function Position:Int64;
  end;

implementation

constructor TExeStream.Create(FName:String;ReadOnly:Boolean);
var
 f:word;
 c:cardinal;
begin
inherited Create;
fmark:=1349469005;
if readonly then f:=fmopenread or fmsharedenynone else f:=fmopenreadwrite;
str:=tfilestream.Create(fname,f);
str.Seek(-4,file_end);
str.Read(c,4);
if c=fmark then
 begin
 str.Seek(-8,file_end);
 str.Read(c,4);
 fstart:=str.Size-c-8;
 str.Seek(fstart,file_begin);
 end
else
 begin
 fstart:=str.Size;
 c:=0;
 str.Write(c,4);
 str.Write(fmark,4);
 str.Seek(fstart,file_begin);
 end;
end;

destructor TExeStream.Destroy;
begin
str.Free;
inherited;
end;

function TExeStream.Read(var Buffer;Count:Integer):Integer;
var k:integer;
begin
if count+str.Position>str.Size-8 then k:=str.Size-str.Position-8 else k:=count;
if k<=0 then
 result:=0
else
 result:=str.Read(buffer,k);
end;

function TExeStream.Write(var Buffer;Count:Integer):Integer;
var
 k:integer;
 j:cardinal;
begin
result:=str.Write(buffer,count);
k:=str.Position;
if k>str.Size-8 then
 begin
 j:=k-fstart;
 str.Write(j,4);
 str.Write(fmark,4);
 str.Seek(k,file_begin);
 end;
end;

function TExeStream.Seek(Offset:Longint;Origin:Word):Longint;
begin
case origin of
 file_begin:str.Seek(fstart,file_begin);
 file_end:str.Seek(-8,file_end);
end;
if offset+str.Position-fstart<0 then
 begin
 result:=-1;
 exit;
 end;
if offset+str.Position>str.Size-8 then
 begin
 result:=-1;
 exit;
 end;
result:=str.Seek(offset,file_current);
if result<>-1 then result:=result-fstart;
end;

function TExeStream.Size:Int64;
begin
result:=str.Size-8-fstart;
end;

function TExeStream.Position:Int64;
begin
result:=str.Position-fstart;
end;

end.
